/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2019 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name        : Config_CMT0_user.c
* Component Version: 2.2.0
* Device(s)        : R5F5651EDxFB
* Description      : This file implements device driver for Config_CMT0.
***********************************************************************************************************************/

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "Config_CMT0.h"
/* Start user code for include. Do not edit comment generated here */
#include "Config_TMR1.h"
#include "io_board.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: R_Config_CMT0_Create_UserInit
* Description  : This function adds user code after initializing the CMT0 channel
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/

void R_Config_CMT0_Create_UserInit(void)
{
    /* Start user code for user init. Do not edit comment generated here */
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_Config_CMT0_cmi0_interrupt
* Description  : This function is CMI0 interrupt service routine
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/

#if FAST_INTERRUPT_VECTOR == VECT_CMT0_CMI0
#pragma interrupt r_Config_CMT0_cmi0_interrupt(vect=VECT(CMT0,CMI0),fint)
#else
#pragma interrupt r_Config_CMT0_cmi0_interrupt(vect=VECT(CMT0,CMI0))
#endif
static void r_Config_CMT0_cmi0_interrupt(void)
{
    /* Start user code for r_Config_CMT0_cmi0_interrupt. Do not edit comment generated here */
	
	volatile unsigned char dummy_c;
	volatile unsigned short x;
	
	setpsw_i();		//multiple interrupt
	
	//wait
	if(g_wait_x100_us_counter != 0)
	{
		g_wait_x100_us_counter--;
	}
	
	//ADC - 7Seg
	if(g_adc_val_update_counter == 0)
	{
		g_adc_val_update=1;
		g_adc_val_update_counter=ADC_VAL_UPDATE_INTERVAL;
	}
	g_adc_val_update_counter--;
	
	//7seg
	PORT7.PODR.BYTE &= 0x0F;			//COM:disable
	
	if(g_seg_flag == 0)
	{
		PORTA.PODR.BYTE = 0x00;			//SEG:disable
	}
	else
	{
		switch(g_seg_com)				//COM:select
		{
			case 0:
				PORT7.PODR.BIT.B4=1;
				break;
			case 1:
				PORT7.PODR.BIT.B5=1;
				break;
			case 2:
				PORT7.PODR.BIT.B6=1;
				break;
			case 3:
				PORT7.PODR.BIT.B7=1;
				break;
			default:
				break;
		}
		PORTA.PODR.BYTE = seg_drive(g_seg_char[g_seg_com], g_seg_dp[g_seg_com]);	//SEG:set
		
		g_seg_com++;
		if(g_seg_com >= 4) g_seg_com=0;
	}
	
	//Matrix-SW
	PORT6.PODR.BYTE |= 0xf0;
	
	switch(g_matrix_scan)
	{
		case 0:
			PORT6.PODR.BIT.B4=0;
			break;
		case 1:
			PORT6.PODR.BIT.B5=0;
			break;
		case 2:
			PORT6.PODR.BIT.B6=0;
			break;
		case 3:
			PORT6.PODR.BIT.B7=0;
			break;
		default:
			break;
	}
	
	for(x=0; x<10; x++) nop();	//1us wait, [1us > 12kOhm(pull-up) x 20pF = 240ns]

	g_matrix_sw[g_matrix_scan] = PORT6.PIDR.BYTE & 0x0f;
			
	g_matrix_scan++;
	if(g_matrix_scan >= 4) g_matrix_scan=0;
	
    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
