/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2019 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name        : Config_ICU_user.c
* Component Version: 2.2.0
* Device(s)        : R5F5651EDxFB
* Description      : This file implements device driver for Config_ICU.
***********************************************************************************************************************/

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "Config_ICU.h"
/* Start user code for include. Do not edit comment generated here */
#include "Config_TMR1.h"
#include "Config_TPU2.h"
#include "sci.h"
#include "lcd_1602.h"
#include "io_board.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: R_Config_ICU_Create_UserInit
* Description  : This function adds user code after initializing the ICU module
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/

void R_Config_ICU_Create_UserInit(void)
{
    /* Start user code for user init. Do not edit comment generated here */
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_Config_ICU_irq4_interrupt
* Description  : This function is IRQ4 interrupt service routine
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/

#if FAST_INTERRUPT_VECTOR == VECT_ICU_IRQ4
#pragma interrupt r_Config_ICU_irq4_interrupt(vect=VECT(ICU,IRQ4),fint)
#else
#pragma interrupt r_Config_ICU_irq4_interrupt(vect=VECT(ICU,IRQ4))
#endif
static void r_Config_ICU_irq4_interrupt(void)
{
    /* Start user code for r_Config_ICU_irq4_interrupt. Do not edit comment generated here */
	
	lcd_hs2();
	lcd_write_str("IRQ4 ");
	sci_write_str("\n***IRQ4  detected ***\n\n");
	
	switch(g_seg_state)
	{
		
		//ON -> HOLD -> OFF toggle
		
		case OFF:
			g_seg_state=ON;
			break;
			
		case ON:
			g_seg_state=HOLD;
			break;
			
		case HOLD:
			g_seg_state=OFF;
			break;
		
		default:
			break;
	}
	
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_Config_ICU_irq13_interrupt
* Description  : This function is IRQ13 interrupt service routine
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/

#if FAST_INTERRUPT_VECTOR == VECT_ICU_IRQ13
#pragma interrupt r_Config_ICU_irq13_interrupt(vect=VECT(ICU,IRQ13),fint)
#else
#pragma interrupt r_Config_ICU_irq13_interrupt(vect=VECT(ICU,IRQ13))
#endif
static void r_Config_ICU_irq13_interrupt(void)
{
    /* Start user code for r_Config_ICU_irq13_interrupt. Do not edit comment generated here */
	
	lcd_hs2();
	lcd_write_str("IRQ13");
	sci_write_str("\n***IRQ13 detected ***\n\n");
	
	switch(g_led8_flag)
	{
		case ON:
			g_led8_flag=OFF;
	
			R_Config_TPU2_Stop();
					
			//LED8(P15) -> Hi-Z
			PORT1.PMR.BIT.B5 = 0;  
			PORT1.PDR.BIT.B5 = 0;
	
			break;
	
		case OFF:
			g_led8_flag=ON;
			
			//LED8(P15) -> TPU2
			PORT1.PMR.BIT.B5 = 1;
			
			R_Config_TPU2_Start();
		
			break;
			
		default:
			break;
	}
	
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_Config_ICU_irq15_interrupt
* Description  : This function is IRQ15 interrupt service routine
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/

#if FAST_INTERRUPT_VECTOR == VECT_ICU_IRQ15
#pragma interrupt r_Config_ICU_irq15_interrupt(vect=VECT(ICU,IRQ15),fint)
#else
#pragma interrupt r_Config_ICU_irq15_interrupt(vect=VECT(ICU,IRQ15))
#endif
static void r_Config_ICU_irq15_interrupt(void)
{
    /* Start user code for r_Config_ICU_irq15_interrupt. Do not edit comment generated here */
	
	lcd_hs2();
	lcd_write_str("IRQ15");
	sci_write_str("\n***IRQ15 detected ***\n\n");
	
	switch(g_buzz_flag)
	{
		case ON:
			g_buzz_flag=OFF;
	
			R_Config_TMR1_Stop();
					
			//BUZZ(P17) -> Hi-Z
			PORT1.PMR.BIT.B7 = 0;  
			PORT1.PDR.BIT.B7 = 0;
					
			//TPM1 pitch initialize
			buzz_pitch(g_buzz_cycle_ar[0]);
	
			break;
	
		case OFF:
			g_buzz_flag=ON;
			
			//BUZZ(P17) -> TMR1
			PORT1.PMR.BIT.B7 = 1;
			
			R_Config_TMR1_Start();
		
			break;
			
		default:
			break;
	}
	
    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

